var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _SenseLogs_defaultFilter, _SenseLogs_destinations, _SenseLogs_flag, _SenseLogs_filter, _SenseLogs_name, _SenseLogs_options, _SenseLogs_override, _SenseLogs_redact, _SenseLogs_sample, _SenseLogs_timestamp, _SenseLogs_top;
const DefaultFilter = ['fatal', 'error', 'metrics', 'info', 'warn'];
export default class SenseLogs {
    constructor(options = { destination: 'stdout' }, context = {}) {
        _SenseLogs_defaultFilter.set(this, void 0);
        _SenseLogs_destinations.set(this, void 0);
        _SenseLogs_flag.set(this, void 0);
        _SenseLogs_filter.set(this, void 0);
        _SenseLogs_name.set(this, void 0);
        _SenseLogs_options.set(this, void 0);
        _SenseLogs_override.set(this, void 0);
        _SenseLogs_redact.set(this, void 0);
        _SenseLogs_sample.set(this, void 0);
        _SenseLogs_timestamp.set(this, void 0);
        _SenseLogs_top.set(this, void 0);
        if (!options.child) {
            __classPrivateFieldSet(this, _SenseLogs_options, Object.assign({}, options), "f");
            __classPrivateFieldSet(this, _SenseLogs_name, options.name || 'app', "f");
            __classPrivateFieldSet(this, _SenseLogs_redact, options.redact, "f");
            __classPrivateFieldSet(this, _SenseLogs_timestamp, options.timestamp || false, "f");
            __classPrivateFieldSet(this, _SenseLogs_top, this, "f");
            __classPrivateFieldSet(this, _SenseLogs_filter, {}, "f");
            __classPrivateFieldSet(this, _SenseLogs_defaultFilter, null, "f");
            __classPrivateFieldSet(this, _SenseLogs_override, {}, "f");
            __classPrivateFieldSet(this, _SenseLogs_sample, {}, "f");
            __classPrivateFieldSet(this, _SenseLogs_destinations, [], "f");
            if (options.flag) {
                if (typeof options.flag == 'string') {
                    __classPrivateFieldSet(this, _SenseLogs_flag, { error: options.flag, fatal: options.flag }, "f");
                }
                else {
                    __classPrivateFieldSet(this, _SenseLogs_flag, options.flag, "f");
                }
            }
            else {
                __classPrivateFieldSet(this, _SenseLogs_flag, {}, "f");
            }
            let filter = options.filter || DefaultFilter;
            if (typeof process != 'undefined' && process.env) {
                if (process.env.LOG_FILTER != null) {
                    filter = process.env.LOG_FILTER;
                }
                if (process.env.LOG_SAMPLE != null) {
                    let [percentage, filter] = process.env.LOG_SAMPLE.split(':');
                    this.setSample(filter, parseInt(percentage));
                }
                if (process.env.LOG_OVERRIDE != null) {
                    let [expire, filter] = process.env.LOG_OVERRIDE.split(':');
                    this.setOverride(filter, expire);
                }
            }
            this.setFilter(filter);
            __classPrivateFieldSet(this, _SenseLogs_defaultFilter, Object.keys(__classPrivateFieldGet(this, _SenseLogs_filter, "f")), "f");
            let format = options.format || 'json';
            if (options.destination == 'console') {
                this.addDestination(new ConsoleDest(options), format);
            }
            else if (options.destination == 'capture') {
                this.addDestination(new CaptureDest(options), format);
            }
            else if (options.destination && typeof options.destination.write == 'function') {
                this.addDestination(options.destination, format);
            }
            else {
                this.addDestination(new StdoutDest(options), format);
            }
            this.addUncaughtExceptions();
        }
        this.context = context;
    }
    addFilter(filter) {
        if (!filter) {
            return this;
        }
        if (!Array.isArray(filter)) {
            if (filter == 'default') {
                filter = DefaultFilter;
            }
            else {
                filter = filter.split(',').map(f => f.trim());
            }
        }
        for (let chan of filter) {
            if (chan) {
                __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_filter, "f")[chan] = true;
            }
        }
        return this;
    }
    setFilter(filter) {
        __classPrivateFieldSet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_filter, {}, "f");
        if (filter) {
            return this.addFilter(filter);
        }
        return this;
    }
    getFilter() {
        return Object.keys(__classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_filter, "f"));
    }
    getOverride() {
        return __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_override, "f");
    }
    getSample() {
        return __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_sample, "f");
    }
    setOverride(filter, expire) {
        let top = __classPrivateFieldGet(this, _SenseLogs_top, "f");
        if (!filter) {
            __classPrivateFieldSet(top, _SenseLogs_override, {}, "f");
            return this;
        }
        if (!expire) {
            expire = Date.now();
        }
        if (!Array.isArray(filter)) {
            filter = filter.split(',').map(f => f.trim());
        }
        for (let chan of filter) {
            if (chan) {
                __classPrivateFieldGet(top, _SenseLogs_override, "f")[chan] = expire;
            }
        }
        return this;
    }
    setSample(filter, rate) {
        if (!filter) {
            __classPrivateFieldSet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_sample, {}, "f");
            return this;
        }
        if (rate == null) {
            rate = 0;
        }
        if (rate > 100) {
            rate = 100;
        }
        if (!Array.isArray(filter)) {
            filter = filter.split(',').map(f => f.trim());
        }
        if (rate > 0) {
            for (let chan of filter) {
                if (chan) {
                    __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_sample, "f")[chan] = { count: 0, total: 100 / rate };
                }
            }
        }
        else {
            for (let chan of filter) {
                if (chan) {
                    __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_sample, "f")[chan] = null;
                }
            }
        }
        return this;
    }
    child(context) {
        context = context ? Object.assign({}, this.context, context) : this.context;
        let log = new SenseLogs({ child: true }, context);
        __classPrivateFieldSet(log, _SenseLogs_top, __classPrivateFieldGet(this, _SenseLogs_top, "f"), "f");
        return log;
    }
    addDestination(dest, format = 'json') {
        __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_destinations, "f").push({ dest, format });
        return this;
    }
    setDestination(dest, format = 'json') {
        __classPrivateFieldSet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_destinations, [], "f");
        __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_destinations, "f").push({ dest, format });
        return this;
    }
    addContext(contexts) {
        if (!Array.isArray(contexts)) {
            contexts = [contexts];
        }
        for (let context of contexts) {
            this.context = Object.assign(this.context, context);
        }
        return this;
    }
    clearContext() {
        this.context = {};
        return this;
    }
    enabled(chan, inc = 0) {
        let top = __classPrivateFieldGet(this, _SenseLogs_top, "f");
        if (__classPrivateFieldGet(top, _SenseLogs_filter, "f")[chan] == null) {
            if (__classPrivateFieldGet(top, _SenseLogs_override, "f")[chan] && __classPrivateFieldGet(top, _SenseLogs_override, "f")[chan] < Date.now()) {
                __classPrivateFieldGet(top, _SenseLogs_override, "f")[chan] = null;
            }
            if (__classPrivateFieldGet(top, _SenseLogs_override, "f")[chan] == null) {
                let sample = __classPrivateFieldGet(top, _SenseLogs_sample, "f")[chan];
                if (sample == null) {
                    return false;
                }
                sample.count += inc;
                if (sample.count < sample.total) {
                    return false;
                }
                sample.count = 0;
            }
        }
        return true;
    }
    process(chan, message, context = {}) {
        let top = __classPrivateFieldGet(this, _SenseLogs_top, "f");
        context = this.prepare(chan, message, context);
        if (context == null) {
            return;
        }
        if (__classPrivateFieldGet(top, _SenseLogs_redact, "f")) {
            context = __classPrivateFieldGet(top, _SenseLogs_redact, "f").call(top, context);
        }
        for (let { dest, format } of __classPrivateFieldGet(top, _SenseLogs_destinations, "f")) {
            if (context) {
                let message = this.format(context, format);
                dest.write(top, context, message);
            }
        }
    }
    prepare(chan, message, context = {}) {
        let top = __classPrivateFieldGet(this, _SenseLogs_top, "f");
        chan = context['@chan'] || chan;
        if (!this.enabled(chan, 1)) {
            return null;
        }
        let exception;
        if (context instanceof Error) {
            exception = context;
            context = {};
        }
        else {
            context = Object.assign({}, context);
        }
        if (message instanceof Error) {
            exception = message;
            message = exception.message;
        }
        else if (context.err instanceof Error) {
            exception = context.err;
            delete context.err;
        }
        if (exception) {
            let err = context['@exception'] = JSON.parse(JSON.stringify(exception, Object.getOwnPropertyNames(exception)), null, 4);
            err.stack = err.stack.split('\n').slice(1).map(r => r.trim());
        }
        if (context['@stack'] === true) {
            try {
                context['@stack'] = (new Error('stack')).stack.split('\n').slice(1).map(r => r.trim());
            }
            catch (err) { }
        }
        if (context.message) {
            context['@message'] = context.message;
        }
        context.message = (typeof message == 'string') ? message : JSON.stringify(message);
        context['@chan'] = chan;
        context['@module'] = context['@module'] || __classPrivateFieldGet(top, _SenseLogs_name, "f");
        if (__classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_timestamp, "f")) {
            context.timestamp = new Date();
        }
        let flag = __classPrivateFieldGet(top, _SenseLogs_flag, "f");
        if (flag[chan]) {
            context[flag[chan]] = true;
        }
        return Object.assign({}, this.context, context);
    }
    format(context, format) {
        let chan = context['@chan'];
        let message;
        if (format == 'json') {
            message = this.jsonFormat(context);
        }
        else if (format == 'human') {
            message = this.humanFormat(context);
        }
        else if (format == 'tsv') {
            message = this.tsvFormat(context);
        }
        else if (format == 'keyvalue') {
            message = this.keyValueFormat(context);
        }
        else if (typeof format == 'function') {
            message = format(context);
        }
        else {
            message = this.jsonFormat(context);
        }
        return message;
    }
    jsonFormat(context) {
        return JSON.stringify(context);
    }
    tsvFormat(context) {
        let message = [new Date().toISOString()];
        for (let value of Object.values(context)) {
            message.push(value);
        }
        message = message.join('\t');
        return message;
    }
    keyValueFormat(context) {
        let message = [`"date"="${new Date().toISOString()}"`];
        for (let [key, value] of Object.entries(context)) {
            message.push(`"${key}"="${value}"`);
        }
        message = message.join(',');
        return message;
    }
    humanFormat(context) {
        let time = this.getTime();
        let exception = context['@exception'];
        let prefix = context['@chan'].toUpperCase();
        let message;
        if (exception) {
            message = `${time}: ${prefix}: ${context.message}` + '\n' + exception + '\n' + JSON.stringify(context, null, 4);
        }
        else {
            message = `${time}: ${prefix}: ${context.message}`;
            if (Object.keys(context).length > 3) {
                message += ' ' + JSON.stringify(context, null, 4);
            }
        }
        return message;
    }
    assert(truthy, message = '', context = {}) {
        if (!(Boolean(truthy) && truthy != 'false')) {
            message = 'Assert failed' + (message ? `: ${message}` : '');
            this.process('assert', message, context);
        }
    }
    data(message, context) { this.process('data', message, context); }
    debug(message, context) { this.process('debug', message, context); }
    error(message, context) { this.process('error', message, context); }
    fatal(message, context) { this.process('fatal', message, context); }
    info(message, context) { this.process('info', message, context); }
    silent(message, context) { this.process('silent', message, context); }
    trace(message, context) { this.process('trace', message, context); }
    warn(message, context) { this.process('warn', message, context); }
    flush(what) {
        let buffer;
        for (let { dest } of __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_destinations, "f")) {
            buffer = dest.flush(__classPrivateFieldGet(this, _SenseLogs_top, "f"), what);
        }
        return buffer;
    }
    emit(chan, message, context) {
        this.process(chan, message, context);
    }
    metrics(chan, message, namespace, values, dimensions = [], units = null, properties = {}) {
        let top = __classPrivateFieldGet(this, _SenseLogs_top, "f");
        if (!__classPrivateFieldGet(top, _SenseLogs_filter, "f").metrics) {
            return;
        }
        if (!namespace || !values) {
            throw new Error('Missing namespace or values');
        }
        if (!this.enabled(chan, 1)) {
            return;
        }
        let keys = Object.keys(values).filter(v => dimensions.indexOf(v) < 0);
        let metrics = keys.map(name => {
            let def = { Name: name };
            if (units) {
                let unit = units[name] || units.default;
                if (unit) {
                    def.Unit = unit;
                }
            }
            return def;
        });
        let context = {
            '@chan': chan,
            '@namespace': namespace,
            '@metrics': keys,
            message: message + ' ' + JSON.stringify(Object.assign({
                _aws: {
                    Timestamp: Date.now(),
                    CloudWatchMetrics: [{
                            Dimensions: [dimensions],
                            Namespace: namespace,
                            Metrics: metrics,
                        }]
                },
            }, properties, values))
        };
        for (let { dest } of __classPrivateFieldGet(__classPrivateFieldGet(this, _SenseLogs_top, "f"), _SenseLogs_destinations, "f")) {
            dest.write(__classPrivateFieldGet(this, _SenseLogs_top, "f"), context, context.message);
        }
    }
    addUncaughtExceptions() {
        let self = this;
        if (typeof window != 'undefined') {
            global.onerror = function (message, module, line, column, err) {
                self.error(message, { err });
            };
            global.onunhandledrejection = (rejection) => {
                let message = `Unhandled promise rejection : ${rejection.message}`;
                if (rejection && rejection.reason && rejection.reason.stack) {
                    message += `\r${rejection.reason.stack}`;
                }
                self.error(message);
            };
        }
    }
    addNodeExceptions() {
        let self = this;
        if (typeof process != 'undefined') {
            process.on("uncaughtException", function (err) {
                self.error('Uncaught exception', { err });
            });
        }
    }
    getTime() {
        let now = new Date();
        return `${this.zpad(now.getHours(), 2)}:${this.zpad(now.getMinutes(), 2)}:${this.zpad(now.getSeconds(), 2)}`;
    }
    zpad(n, size) {
        let s = n + '';
        while (s.length < size)
            s = '0' + s;
        return s;
    }
}
_SenseLogs_defaultFilter = new WeakMap(), _SenseLogs_destinations = new WeakMap(), _SenseLogs_flag = new WeakMap(), _SenseLogs_filter = new WeakMap(), _SenseLogs_name = new WeakMap(), _SenseLogs_options = new WeakMap(), _SenseLogs_override = new WeakMap(), _SenseLogs_redact = new WeakMap(), _SenseLogs_sample = new WeakMap(), _SenseLogs_timestamp = new WeakMap(), _SenseLogs_top = new WeakMap();
class CaptureDest {
    constructor() {
        this.messages = [];
        this.contexts = [];
    }
    flush(log, what = 'context') {
        let result = what == 'message' ? this.messages : this.contexts;
        this.messages = [];
        this.contexts = [];
        return result;
    }
    write(log, context, message) {
        this.messages.push(message);
        this.contexts.push(context);
    }
}
class ConsoleDest {
    write(log, context, message) {
        if (context['@chan'] == 'error') {
            console.error(message);
        }
        else {
            console.log(message);
        }
    }
}
class StdoutDest {
    constructor(options) {
        this.stdout = process.stdout || { write: this.output };
    }
    write(log, context, message) {
        this.stdout.write(message + '\n');
    }
    output(msg) {
        console.log(msg);
    }
}
